#!/usr/bin/env bash

declare -A LTS_TABLE
LTS_TABLE=(
    ["2023.10"]="luna"
    ["2023.05"]="kuma"
    ["2022.10"]="jabbah"
    ["2022.05"]="izar"
    ["2021.15"]="helios"
    ["2021.07"]="gaia"
    ["2020.18"]="freya"
    ["2020.07"]="electra"
    ["2019.12"]="deneb"
    ["2019.05"]="callisto"
    ["2018.16"]="borealis"
    ["2018.05"]="aldebaran"
    ["2017.11"]="polaris"
    ["2017.03"]="five"
)
CURRENT_LTS="maia"
IS_CURRENT_LTS_RELEASED=true

verify_version() {
    if [[ ! ${1} =~ [0-9]{4}\.[0-9]{2} ]]; then
        echo "Error: Version ${1} is not a valid xivo.solutions format"
        exit_abnormally
    fi
}

verify_numeric_version() {
    if [[ ! ${1} =~ [0-9]{4}\.[0-9]{2}\.[0-9]{2} ]]; then
        echo "Error: Version.Subversion ${1} is not a valid xivo.solutions format"
        exit 1
    fi
}

set_lts_codename() {
    if [[ -v LTS_TABLE[$1] ]]; then
        LTS_CODENAME=${LTS_TABLE[$1]}
    else
        LTS_CODENAME="${CURRENT_LTS}"
    fi
}

set_branch() {
    version_table=("${!LTS_TABLE[@]}")

    if [[ "${version_table[*]}" =~ ${1} ]]; then
        BRANCH="${1}"
    else
        BRANCH="master"
    fi
}
